<?php
header("Content-Type: text/html; charset=utf-8");
require_once("../../../config.php");

$context   = $_SESSION[MYAP]['context'];
$extension = $_SESSION[MYAP]['extension'];

$permit    = $_SESSION[MYAP]['permit'];
$admin     = isset($_SESSION[MYAP]['admin'])?$_SESSION[MYAP]['admin']:0;
$permisos  = preg_split("/,/",$permit);

if(in_array("callhistory",$permisos) || in_array("all",$permisos)) {
    $allowed='yes';
} else {
    $allowed='no';
}

$cdrdatabase = "asteriskcdrdb";

$rooms=array();
$rooms_query = "SELECT DISTINCT(room) FROM $cdrdatabase.conference_log";
$res = $db->consulta($rooms_query);
while($row=$db->fetch_row($res)) {
    $rooms[]=$row[0];
}

$today = date('m-d-Y');

function to_mysql_date($date) {
    $parts = preg_split("/\//",$date);
    return $parts[2]."-".$parts[0]."-".$parts[1];
}

if(isset($_REQUEST['start'])) {
    $start = to_mysql_date($_REQUEST['start']);
    $start .= " 00:00:00";
    $startform = $_REQUEST['start'];
} else {
    $start = date('Y-m-d 00:00:00');
    $startform = $today;
}

if(isset($_REQUEST['end'])) {
    $end = to_mysql_date($_REQUEST['end']);
    $end .= " 23:59:59";
    $endform = $_REQUEST['end'];
} else {
    $end = date('Y-m-d 23:59:59');
    $endform = $today;
}

$selected_rooms = array();
$rooms_query_string = '';
if(isset($_REQUEST['room'])) {
    $selected_rooms = $_REQUEST['room'];
    $rooms_query_string = "AND room IN ('".implode("','",$selected_rooms)."') ";

}

$initquery = "SELECT @start:=NULL, @stop:=NULL, @uniqueid:=NULL;";

$query = "SELECT a.uniqueid,room,start,stop,duration,participants FROM (SELECT id, uniqueid, room, UNIX_TIMESTAMP(start) AS start, UNIX_TIMESTAMP(stop) AS stop,  TIMESTAMPDIFF(SECOND, start, stop) AS duration  FROM (  SELECT id, datetime, room, event, (@uniqueid <> uniqueid) AS new_uniqueid,  @start AS start, @start := IF (event = 'START', datetime, NULL) AS prev_start,  @stop  := IF(event = 'END', datetime, NULL) AS stop, @uniqueid := uniqueid AS uniqueid  FROM $cdrdatabase.conference_log WHERE event IN ('START','END') ORDER BY uniqueid, datetime)  AS tmp, (SELECT @start:=NULL, @stop:=NULL, @uniqueid:=NULL) AS vars  WHERE new_uniqueid = 0 AND start IS NOT NULL AND stop IS NOT NULL AND UNIX_TIMESTAMP(start)>=UNIX_TIMESTAMP('$start') AND UNIX_TIMESTAMP(stop) <= UNIX_TIMESTAMP('$end') $rooms_query_string) a LEFT JOIN (select uniqueid,max(info1) AS participants from $cdrdatabase.conference_log where event='PARTICIPANTS' group by uniqueid) b ON b.uniqueid=a.uniqueid";

?>
<!DOCTYPE html>
<html>
<head>
<?php
if(isset($page_title)) { 
    echo "    <title>$page_title></title>\n"; 
} else {
    echo "    <title>".TITLE."</title>\n"; 
}

if($allowed=="no") {
    echo "<meta http-equiv=\"refresh\" content=\"5\" >\n";
}

?>
    <base href='../../../'>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="imagetoolbar" content="false"/>
    <meta name="MSSmartTagsPreventParsing" content="true"/>
    <meta name="description" content=""/>
    <meta name="keywords" content=""/>
    <link rel="stylesheet" type="text/css" href="css/jconf.css" />
    <link rel="stylesheet" type="text/css" href="css/chosen.css" />
    <link rel="stylesheet" type="text/css" href="css/jquery.noty.css" />
    <link href="css/bootstrap.min.css" media="screen" rel="stylesheet" type="text/css">
    <link rel="stylesheet" type="text/css" href="css/bootstrap.datepicker.css" />
    <link rel="stylesheet" type="text/css" href="css/dbgrid.css" />
    <link rel="stylesheet" type="text/css" href="css/flags.css" />
    <link rel="stylesheet" type="text/css" href="css/animate.css" />
    <link href="css/bootstrap-select.css" media="screen" rel="stylesheet" type="text/css">
    <script src="js/jquery-1.11.3.min.js" type="text/javascript"></script>
    <script src="js/moment-with-locales.js"></script>
    <script type="text/javascript" src="js/jquery.plugin.js"></script>
    <script type="text/javascript" src="js/jquery.noty.js"></script>
    <script type="text/javascript" src="js/chosen.jquery.min.js"></script>
    <script type="text/javascript" src="js/jquery.jconf.js"></script>
    <script src="js/bootstrap.min.js" type="text/javascript"></script>
    <script src="js/bootstrap-switch.min.js" type="text/javascript"></script>
    <script src="js/bootstrap-dropdown-on-hover.js " type="text/javascript"></script>
    <script type="text/javascript" src="js/bootstrap.datepicker.js"></script>
    <script type="text/javascript" src="js/jquery.datetimeentry.js"></script>
    <script type="text/javascript" src="js/jquery.tools.form.min.js"></script>
    <script type="text/javascript" src="js/jquery.colresizable.min.js"></script>
    <script type="text/javascript" src="js/jquery.browser.js"></script>
    <script type="text/javascript" src="js/jquery.autoheight.js"></script>
    <script src="js/bootstrap-select.js" type="text/javascript"></script>
<?php
if(isset($extrahead)) {
    foreach($extrahead as $bloque) {
        echo "$bloque";
    }
}
?>
<script>

jQuery(document).ready(function($) {

    jQuery.ajaxSetup({async: false});
    $.getScript("js/presence.js", function() {
        var ret = jQuery.getScript("js/lang_"+language+".js");
        if(ret==1) {
            jQuery.getScript("js/lang_en.js");
        }
        $('.clicktodial').attr('data-original-title',lang.dial);
    });
    jQuery.ajaxSetup({async: true});

    $('.selectpicker').selectpicker({
      style: 'btn-default',
      size: 4,
      'noneSelectedText': '<?php echo trans('All');?>'
    });

    $('#datepicker1').datetimepicker( { useCurrent: true, showTodayButton:true, format: 'MM/DD/YYYY' });
    $('#datepicker2').datetimepicker( { useCurrent: false, format: 'MM/DD/YYYY' });
    $("#datepicker1").on("dp.change", function (e) {
        $('#datepicker2').data("DateTimePicker").minDate(e.date);
    });
    $("#datepicker2").on("dp.change", function (e) {
        $('#datepicker1').data("DateTimePicker").maxDate(e.date);
    });

});


function debug(message) {
    if(window.console !== undefined) {
        console.log(message);
    }
};

function demoFromHTML() {
    var pdf = new jsPDF('p', 'pt', 'letter');

    pdf.cellInitialize();
    pdf.setFontSize(10);
    $.each( $('#conferencereport tr'), function (i, row){
        $.each( $(row).find("td, th"), function(j, cell){
            var txt = $(cell).text().trim() || " ";
            var width = (j==4) ? 40 : 70; //make 4th column smaller
            pdf.cell(10, 50, width, 30, txt, i);
        });
    });

    pdf.save('sample-file.pdf');
}

        function demoFromHTMLx() {
            var pdf = new jsPDF('p', 'pt', 'letter');
            source = $('#conferencereport')[0];

            specialElementHandlers = {
                '#bypassme': function(element, renderer) {
                    return true
                }
            };
            margins = {
                top: 80,
                bottom: 60,
                left: 40,
                width: 522
            };
            pdf.fromHTML(
                    source, // HTML string or DOM elem ref.
                    margins.left, // x coord
                    margins.top, {// y coord
                        'width': margins.width, // max width of content on PDF
                        'elementHandlers': specialElementHandlers
                    },
            function(dispose) {
                pdf.save('conferenceReport.pdf');
            }
            , margins);
        }


</script>

</head>
<body style='overflow-x: hidden;'>
<div class='xcontainer-fluid'>

<?php
$allowed='yes';
if($allowed <> "yes") {
    
    if(!isset($_SESSION[MYAP]['retries'])) {
        $_SESSION[MYAP]['retries']=1;
    } else {
        $_SESSION[MYAP]['retries']++;
    }

   echo "<div class='container-fluid text-center'><br/>";

   if($_SESSION[MYAP]['retries']>10) {
       echo "<h3 class='animated tada'>You do not have permissions to access this resource</h3>";
       echo "<br/><br/><btn class='btn btn-default' onclick='javascript:window.location.reload();'>Refresh</button>";
   } else {
       echo "<h3>Please wait...</h3>";
   }
   echo "</div>";
   die();
}
?>
<div class="panel panel-default">
  <div class="panel-body">


<form class="form-inline">
<div class="form-group">
<label for='room[]'>Rooms:</label>
<select class='selectpicker' multiple class='form-control' name='room[]' id='rooms'>
<?php
foreach($rooms as $room) {
    echo "<option value='$room' ";
    if(in_array($room,$selected_rooms)) { echo " selected "; }
    echo ">$room</option>\n";
}
?>
</select>
</div>

<div class="form-group">
<label for='datestart'>Start:</label>
    <div class='input-group date' id='datepicker1'>
        <input type='text' class="form-control" name='start' value='<?php echo $startform;?>'/>
        <span class="input-group-addon">
            <span class="glyphicon glyphicon-calendar"></span>
        </span>
    </div>
</div>

<div class="form-group">
<label for='datestart'>End:</label>
    <div class='input-group date' id='datepicker2'>
        <input type='text' class="form-control" name='end' value='<?php echo $endform;?>'/>
        <span class="input-group-addon">
            <span class="glyphicon glyphicon-calendar"></span>
        </span>
    </div>
</div>

<button type="submit" class="btn btn-default">Run Report</button>
<!--button onclick="javascript:demoFromHTML()" class="btn btn-default">PDF</button-->
</form>

</div></div>
<div class="panel panel-default">
  <div class="panel-body">
<?php
$res = $db->consulta($initquery);
$res = $db->consulta($query);

echo "<div id='conferencereport'><table class='table table-striped table-bordered' id='conferencereportx'>";
while($row = $db->fetch_assoc($res)) {
    $uniqueid     = $row['uniqueid'];
    $room         = $row['room'];
    $dstart       = date('m/d/Y H:i:s', $row['start']);
    $dend         = date('m/d/Y H:i:s', $row['stop']);
    $duration     = ceil($row['duration']/60);
    $participants = $row['participants'];


    echo "<tr style='background-color: #ddd;'>";
    echo "<td>".trans('Room')."<br><span style='font-weight:bold;'>$room</span></td>";
    echo "<td>".trans('Start')."<br><span style='font-weight:bold;'>$dstart</span></td>";
    echo "<td>".trans('End')."<br><span style='font-weight:bold;'>$dend</span></td>";
    echo "<td>".trans('Minutes')."<br><span style='font-weight:bold;'>$duration</span></td>";
    echo "<td>".trans('Atendees')."<br><span style='font-weight:bold;'>$participants</span></td>";
    echo "</tr>";

    echo "<tr><td colspan=5>"; 

    echo "<table class='table' border=1>";
    echo "<thead><tr>"; 
    echo "<th>".trans('Connect')."</th>";
    echo "<th>".trans('Atendee')."</th>";
    echo "<th>".trans('Minutes')."</th>";
    echo "</tr><tbody>";

    $insidequery = "SELECT uniqueid,UNIX_TIMESTAMP(datetime) AS datetime, info1 AS duration, info2, info3 FROM $cdrdatabase.conference_log WHERE uniqueid='$uniqueid' AND event = 'LEAVE' ORDER BY datetime";
    $insideres   = $db->consulta($insidequery);
    while($atendeerow = $db->fetch_assoc($insideres)) {
        $atstart = date('m/d/Y H:i:s', ($atendeerow['datetime'] - $atendeerow['duration']));
        $atendee = $atendeerow['info2']." ".$atendeerow['info3'];
        $atdur   = ceil($atendeerow['duration']/60);
        
        echo "<tr>"; 
        echo "<td>$atstart</td>";
        echo "<td>$atendee</td>";
        echo "<td>$atdur</td>";
        echo "</tr>";
    }

    echo "</tbody></table>";
    echo "</td></tr>";
}
echo "</table></div>";
?>
</div>
</div>
</div>
</body>
</html>
